/** @file
===========================================================================
MODULE				: CRtvcTee

DESCRIPTIONS		: Tee filter implementation demonstrating how to use the CMultiIOBaseFilter class

REVISION HISTORY	: Version 1.0
					  


COPYRIGHT			: (c)CSIR, Meraka Institute 2007 all rights reserved

RESTRICTIONS		: The information/data/code contained within this file is 
						the property of CSIR, Meraka Institute and has been 
						classified as PUBLIC.
===========================================================================
*/

#pragma once

#include <DirectShow/MultiIOBaseFilter.h>

// {2BA06815-01F7-43fd-B1F3-55354400E849}
static const GUID CLSID_RtvcTee = 
{ 0x2ba06815, 0x1f7, 0x43fd, { 0xb1, 0xf3, 0x55, 0x35, 0x44, 0x0, 0xe8, 0x49 } };


class CRtvcTee : public CMultiIOBaseFilter
{
public:
	/// Constructor
	CRtvcTee();
	/// Destructor
	~CRtvcTee();

	/// Static object-creation method (for the class factory)
	static CUnknown * WINAPI CreateInstance(LPUNKNOWN pUnk, HRESULT *pHr); 

	virtual HRESULT Receive(IMediaSample *pSample, int nIndex );
	
	virtual int InitialNumberOfInputPins() {return 1;}
	virtual int InitialNumberOfOutputPins() { return 1;}
	virtual bool OnFullCreateMoreInputs() { return false;}
	virtual bool OnFullCreateMoreOutputs() { return true; }
	virtual void InitialiseInputTypes();
	virtual void InitialiseOutputTypes();

	///  From CBasePin
	virtual HRESULT CheckOutputType(const CMediaType* pMediaType);


	/// From CBaseOutputPin
	virtual HRESULT DecideBufferSize(IMemAllocator* pAlloc, ALLOCATOR_PROPERTIES* pRequestProperties, int m_nIndex);

	/// To Check media type
	virtual HRESULT GetMediaType(int iPosition, CMediaType* pmt, int nOutputPinIndex) ;

	//STDMETHODIMP Stop();
	//STDMETHODIMP Pause();

protected:

};