/** @file

MODULE					: PicCropperRGB32Impl

TAG						: PCRGB32I

FILE NAME				: PicCropperRGB32Impl.h

DESCRIPTION				: An RGB32 implementation derived from the general
						  PicCropperBase() class. Crop a packed RGB32 image
						  into another packed RGB32 image.

REVISION HISTORY		: 

COPYRIGHT				: (c)CSIR, Meraka Institute 2007 all rights reserved

RESTRICTIONS			: The information/data/code contained within this file is 
						  the property of CSIR, Meraka Institute and has been 
						  classified as PUBLIC.
===========================================================================
*/
#ifndef _PICCROPPERRGB32IMPL_H
#define _PICCROPPERRGB32IMPL_H

#pragma once

#include "PicCropperBase.h"

/*
===========================================================================
  Class definition.
===========================================================================
*/
class PicCropperRGB32Impl: public PicCropperBase
{
public:
	// Construction and destruction.
	PicCropperRGB32Impl(void) { }
	PicCropperRGB32Impl(int widthOut, int heightOut, int widthIn, int heightIn, int left, int right, int top, int bottom): PicCropperBase(widthOut,heightOut,widthIn,heightIn,left,right,top,bottom) { }
	virtual ~PicCropperRGB32Impl(void) {}

	// Interface.
	int Crop(void* pInImg, void* pImg);

};//end PicCropperRGB32Impl.

#endif	// _PICCROPPERRGB32IMPL_H
