/** MediaSample.cpp
===========================================================================
MODULE          : MediaSample

REVISION HISTORY: Version 1.0

COPYRIGHT       : (c)CSIR, Meraka Institute 2008 all rights reserved

RESTRICTIONS	: The information/data/code contained within this file is 
				  the property of CSIR, Meraka Institute and has been 
				  classified as PUBLIC.
===========================================================================
*/
#include "MediaSample.h"

#include <memory>

MediaSample::MediaSample( BYTE* pData, int nSize, double dStartTime, bool bIsSyncPoint)
	: m_nSize(nSize),
	m_dStartTime(dStartTime),
	m_bIsSynchronisationPoint(bIsSyncPoint)
{
	// Copy the data
	m_pData = new BYTE[nSize + 1];
	m_pData[nSize] = '\0';
	memcpy(m_pData, pData, m_nSize);
}

MediaSample::MediaSample( const MediaSample& rSample )
{
	m_nSize = rSample.m_nSize;
	m_dStartTime = rSample.m_dStartTime;
	m_bIsSynchronisationPoint = rSample.m_bIsSynchronisationPoint;
	m_pData = new BYTE[m_nSize + 1];
	m_pData[m_nSize] = '\0';
	memcpy(m_pData, rSample.m_pData, m_nSize);
}

MediaSample::~MediaSample(void)
{
	// Free memory
	delete[] m_pData;
	m_pData = NULL;
}

MediaSample* MediaSample::createMediaSample( BYTE* pData, int nSize, double dStartTime, bool bIsSyncPoint )
{
	return new MediaSample(pData, nSize, dStartTime, bIsSyncPoint);
}

MediaSample& MediaSample::operator=( const MediaSample& rSample )
{
	if (this == &rSample )
	{
		return *this;
	}

	m_nSize = rSample.m_nSize;
	m_dStartTime = rSample.m_dStartTime;
	m_bIsSynchronisationPoint = rSample.m_bIsSynchronisationPoint;
	memcpy(m_pData, rSample.m_pData, m_nSize);
	return *this;
}
